import nltk

#nltk.help.upenn_tagset()
pos_tags = {"$":0,
            "''":1,
            "(":2,
            ")":3,
            ",":4,
            "--":5,
            ".":6,
            ":":7,
            "CC":8,
            "CD":9,
            "DT":10,
            "EX":11,
            "FW":12,
            "IN":13,
            "JJ":14,
            "JJR":15,
            "JJS":16,
            "LS":17,
            "MD":18,
            "NN":19,
            "NNP":20,
            "NNPS":21,
            "NNS":22,
            "PDT":23,
            "POS":24,
            "PRP":25,
            "PRP$":26,
            "RB":27,
            "RBR":28,
            "RBS":29,
            "RP":30,
            "SYM":31,
            "TO":32,
            "UH":33,
            "VB":34,
            "VBD":35,
            "VBG":36,
            "VBN":37,
            "VBP":38,
            "VBZ":39,
            "WDT":40,
            "WP":41,
            "WP$":42,
            "WRB":43,
            "``":44,
            "#":45}

pospass = ["$", "''", "(", ")", ",", "--", ".", ":", "CD", "FW", "LS", "POS", "``", "#"]

wordposs = ["CC", "DT", "EX", "FW", "IN", "JJ", "JJR", "JJS", "MD",
            "NN", "NNP", "NNPS", "NNS", "PDT", "PRP", "PRP$", "RB",
            "RBR", "RBS", "RP", "TO", "UH", "VB", "VBD", "VBG", "VBN",
            "VBP", "VBZ", "WDT", "WP", "WP$", "WRB"]

emotivals = {":D":5,
             ":d":5,
             ":)":5,
             ":-)":5,
             ":-D":5,
             ":-d":5,
             "<3":5,
             ";D":4,
             ";d":4,
             ";-)":4,
             "=D":4,
             "=d":4,
             ";)":4,
             ":]":3,
             "=)":3,
             "(:":3,
             "XD":3,
             "xD":3,
             "Xd":3,
             "xd":3,
             ":\\":-3,
             "D:":-3,
             "d:":-3,
             ":-/":-3,
             ":/":-3,
             ":S":-4,
             ":s":-4,
             ">:(":-4,
             ";(":-4,
             "</3":-5,
             ":-(":-5,
             ":'(":-5,
             ":(":-5}


lssdtargets = ["love", "like", "great", "good", "really", "right", "fun",
               "best", "better", "glad", "yeah", "nice", "awesome", "excited",
               "always", "happy", "cool", "amazing", "favorite", "favourite",
               "perfect", "wonderful", "wonder", "lovely", "super", "fantastic",
               "joy", "cute", "beautiful", "sweet", "hot", "proud", "shocked",
               "interested", "brilliant", "genius", "attractive", "mature"]


#min = -5, max = 5
f = open("dict-AFINN-111.txt", "r", encoding="utf-8")
afinn = dict(map(lambda x : (x[0],float(x[1])), [line.split('\t') for line in f]))
f.close()

#min = -6.925, max = 7.526
f = open("dict-unigrams-pmilexicon.txt", "r", encoding="utf-8")
nrcunigram = dict(map(lambda x : (x[0],float(x[1])), [line.split('\t') for line in f]))
f.close()

#min = -8.639, max = 8.888
f = open("dict-bigrams-pmilexicon.txt", "r", encoding="utf-8")
nrcbigram = dict(map(lambda x : (x[0],float(x[1])), [line.split('\t') for line in f]))
f.close()

#min = -4.999, max = 5
f = open("dict-pairs-pmilexicon.txt", "r", encoding="utf-8")
nrcpair = dict(map(lambda x : (x[0],float(x[1])), [line.split('\t') for line in f]))
f.close()


def semanticValues(tokens):
    bitweet = [x for x in nltk.bigrams(tokens)]
    pairs = []
    for t in tokens:
        for x in tokens:
            pairs.append(t + "---" + x)
        for x in bitweet:
            pairs.append(t + "---" + x[0] + " " + x[1])
    for b in bitweet:
        for x in tokens:
            pairs.append(b[0] + " " + b[1] + "---" + x)
        for x in bitweet:
            pairs.append(b[0] + " " + b[1] + "---" + x[0] + " " + x[1])
    ret_afinn = sum(map(lambda word: afinn.get(word, 0), tokens))
    ret_nrcuni = sum(map(lambda unigram: nrcunigram.get(unigram, 0), tokens))
    ret_nrcbi = sum(map(lambda bigram: nrcbigram.get(bigram[0] + " " + bigram[1], 0), bitweet))
    ret_nrcpair = sum(map(lambda pair: nrcpair.get(pair, 0), pairs))
    ret_emoti = sum(map(lambda emoticon: emotivals.get(emoticon, 0), tokens))
    return [ret_afinn, ret_nrcuni, ret_nrcbi, ret_nrcpair, ret_emoti]

def realLength(tags):
    length = 0
    for t in tags:
        if t[-1] in wordposs:
            length += 1
    if length < 1:
        length = 1
    return length

def posFeatureize(tags):
##    rlen = realLength(tags)
    features = [0 for i in range(46)]
    for x in tags:
        #need to use x[-1] instead of x[1] because a handful of postags get
        #messed up when read from file #spaghetti
        features[pos_tags[x[-1]]] += 1
    toremove = [0 for i in range(46)]
    for x in pospass:
        toremove[pos_tags[x]] = 1
    newftrs = []
    for i in range(46):
        if toremove[i] == 0:
            newftrs.append(features[i])
        
##    for i in range(len(features)):
##        features[i] = (features[i]*10)/rlen
    return features

def inconFeatureize(tokens):
    scoreafi = 0
    scorenrc = 0
    for i in range(len(tokens)-1):
        scoreafi += min(0, afinn.get(tokens[i],0) * afinn.get(tokens[i+1],0))
        scorenrc += min(0, nrcunigram.get(tokens[i],0) * nrcunigram.get(tokens[i+1],0))
    return [scoreafi, scorenrc]

def wordvsemotiFeatureize(afi, uni, bi, pair, emo):
    scoreafi = min(0, (afi * emo)/10.0)
    scorenrc = min(0, ((uni+bi+pair)*emo)/100.0)
    return [scoreafi, scorenrc]

def verbvsrestFeatureize(tags, afi, uni, bi, pair, emo):
    scoreafi = 0
    scorenrc = 0
    for tag in tags:
        if(tag[-1][0] == "V") or (tag[-1][0] == "N"):
            ats = afinn.get(tag[0],0)
            nts = nrcunigram.get(tag[0],0)
            
            #only add if verb/noun has opposite sign to rest of tweet, i.e if the
            #result of the verb/noun sentiment value times the tweet value is less
            #than 0. Using the min function instead of an if test.
            scoreafi += min(0,(afinn.get(tag[0],0) * (afi - ats + emo))/10.0)
            scorenrc += min(0,(nrcunigram.get(tag[0],0) * (uni + bi + pair - nts + emo))/100.0)
    return [scoreafi, scorenrc]

def punctFeatureize(tokens, rlen):
    el = 0
    ex = 0
    qs = 0
    pt = 0
    sc = 0
    cl = 0
    cm = 0
    qt = 0
    for t in tokens:
        if ".." in t:
            el += 1
        if t == "!":
            ex += 1
        if t == "?":
            qs += 1
        if t == ".":
            pt += 1
        if t == ";":
            sc += 1
        if t == ":":
            cl += 1
        if t == ",":
            cm += 1
        if (t == '"') or (t == "'") or (t == "''") or (t == "``"):
            qt += 1
    el = (el*10)/rlen
    ex = (ex*10)/rlen
    qs = (qs*10)/rlen
    pt = (pt*10)/rlen
    sc = (sc*10)/rlen
    cl = (cl*10)/rlen
    cm = (cm*10)/rlen
    qt = (qt*10)/rlen
    return [el, ex, qs, pt, sc, cl, cm, qt]

def lssdFeatureize(tokens, afi, uni, bi, pair, emo):
    scoreafi = 0
    scorenrc = 0
    for t in tokens:
        if(t in lssdtargets):
            ats = afinn.get(t,0)
            nts = nrcunigram.get(t,0)
            scoreafi += min(0,(ats * (afi - ats + emo))/10.0)
            scorenrc += min(0,(nts * (uni + bi + pair - nts + emo))/100.0)      
    return [scoreafi, scorenrc]

def sentFeatureize(afi, uni, bi, pair, emo):
    return[afi, uni+bi+pair, emo]
