import numpy as np
import matplotlib.pyplot as plt
import matplotlib

from sklearn.metrics import confusion_matrix

matplotlib.rcParams.update({'font.size': 16})

#http://matplotlib.org/examples/color/colormaps_reference.html
def plot_confusion_matrix(cm, title='Confusion matrix', cmap=plt.cm.BrBG):
    plt.imshow(cm, interpolation='nearest', cmap=cmap)
    #plt.clim(0,cm.max())
    plt.clim(0,1)
    #plt.title(title)
    plt.colorbar()
    tick_marks = np.arange(2)
    plt.xticks(tick_marks, ['Not Sarcastic','Sarcastic'], rotation=45)
    plt.yticks(tick_marks, ['Not Sarcastic','Sarcastic'])
    plt.tight_layout()
    plt.ylabel('True label')
    plt.xlabel('Predicted label')


# Compute confusion matrix
y_true = []
y_pred = []
S_as_S = 509
N_as_N = 950
N_as_S = 140
S_as_N = 606
for i in range(S_as_S):
    y_true.append(1)
    y_pred.append(1)
for i in range(N_as_N):
    y_true.append(0)
    y_pred.append(0)
for i in range(N_as_S):
    y_true.append(0)
    y_pred.append(1)
for i in range(S_as_N):
    y_true.append(1)
    y_pred.append(0)
cm = confusion_matrix(y_true, y_pred)
np.set_printoptions(precision=2)
##print('Confusion matrix, without normalization')
##print(cm)
##plt.figure()
##plot_confusion_matrix(cm)

# Normalize the confusion matrix by row (i.e by the number of samples
# in each class)
cm_normalized = cm.astype('float') / cm.sum(axis=1)[:, np.newaxis]
print('Normalized confusion matrix')
print(cm_normalized)
plt.figure()
plot_confusion_matrix(cm_normalized, title='Normalized confusion matrix')

plt.savefig('LRegAllMAD2auto.png', bbox_inches='tight') #.pdf .jpg
plt.show()
